* config/v850/tm-v850.h: Use distinct register for PC, not EIPC.
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk"
53
54
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
57 #
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
63 #
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
67 #
68 target_tools="target-examples target-groff"
69
70 ################################################################################
71
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
77
78 # directories to be built in the native environment only
79 #
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84 # directories to be built in a cross environment only
85 #
86 cross_only="target-libiberty target-libgloss target-newlib"
87
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
93 #
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
96
97 ################################################################################
98
99 srctrigger=move-if-change
100 srcname="gnu development package"
101
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
104
105 # per-host:
106
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
114 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
115 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
116 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
117 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
118 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
119 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
120 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
121 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
122 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
123 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
124 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
125 i[3456]86-*-dgux*) host_makefile_frag=config/mh-sysv4 ;;
126 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
127 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
128 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
129 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
130 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
131 i[3456]86-*-linux*) host_makefile_frag=config/mh-linux ;;
132 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
133 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
134 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
135 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
136 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
137 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
138 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
139 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
140 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
141 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
142 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
143 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
144 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
145 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
146 esac
147 fi
148
149 # If we aren't going to be using gcc, see if we can extract a definition
150 # of CC from the fragment.
151 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
152 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
153 found=
154 for dir in $PATH; do
155 test -z "$dir" && dir=.
156 if test -f $dir/gcc; then
157 found=yes
158 break
159 fi
160 done
161 IFS="$save_ifs"
162 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
163 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
164 if [ -n "${xx}" ] ; then
165 CC=$xx
166 fi
167 fi
168 fi
169
170 # We default to --with-shared on platforms where -fpic is meaningless.
171 # Well, we don't yet, but we will.
172 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
173 case "${target}" in
174 alpha-dec-osf*) enable_shared=yes ;;
175 alpha-*-linux*) enable_shared=yes ;;
176 mips-sgi-irix5*) enable_shared=yes ;;
177 *) enable_shared=no ;;
178 esac
179 fi
180
181 case "${enable_shared}" in
182 yes) shared=yes ;;
183 no) shared=no ;;
184 "") shared=no ;;
185 *) shared=yes ;;
186 esac
187
188 if [ x${shared} = xyes ]; then
189 waugh=
190 case "${host}" in
191 hppa*) waugh=config/mh-papic ;;
192 i[3456]86-*) waugh=config/mh-x86pic ;;
193 sparc64-*) waugh=config/mh-sparcpic ;;
194 *) waugh=config/mh-${host_cpu}pic ;;
195 esac
196 if [ -f ${srcdir}/${waugh} ]; then
197 if [ -n "${host_makefile_frag}" ] ; then
198 cat ${srcdir}/${host_makefile_frag} > mh-frag
199 cat ${srcdir}/${waugh} >> mh-frag
200 host_makefile_frag=mh-frag
201 else
202 host_makefile_frag=${waugh}
203 fi
204 fi
205 fi
206
207 # per-target:
208
209 case "${target}" in
210 v810*) target_makefile_frag=config/mt-v810 ;;
211 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
212 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
213 powerpc*-*-eabi* | \
214 powerpc*-*-elf* | \
215 powerpc*-*-linux* | \
216 powerpc*-*-rtem* | \
217 powerpc*-*-sysv* | \
218 powerpc*-*-solaris*) target_makefile_frag=config/mt-ppc ;;
219 esac
220
221 skipdirs=
222 gasdir=gas
223 use_gnu_ld=
224 use_gnu_as=
225
226 # some tools are so dependent upon X11 that if we're not building with X,
227 # it's not even worth trying to configure, much less build, that tool.
228
229 case ${with_x} in
230 yes | "") # the default value for this tree is that X11 is available
231 ;;
232 no)
233 skipdirs="${skipdirs} tk gash"
234 ;;
235 *)
236 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
237 ;;
238 esac
239
240 # Some tools are only suitable for building in a "native" situation.
241 # Those are added when we have a host==target configuration. For cross
242 # toolchains, we add some directories that should only be useful in a
243 # cross-compiler.
244
245 is_cross_compiler=
246
247 if [ x"${host}" = x"${target}" ] ; then
248 # when doing a native toolchain, don't build the targets
249 # that are in the 'cross only' list
250 skipdirs="${skipdirs} ${cross_only}"
251 is_cross_compiler=no
252 target_subdir=.
253 else
254 # similarly, don't build the targets in the 'native only'
255 # list when building a cross compiler
256 skipdirs="${skipdirs} ${native_only}"
257 is_cross_compiler=yes
258 target_subdir=${target_alias}
259 if [ ! -d ${target_subdir} ] ; then
260 if mkdir ${target_subdir} ; then true
261 else
262 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
263 exit 1
264 fi
265 fi
266 fi
267
268 copy_dirs=
269
270 # Handle --with-headers=XXX. The contents of the named directory are
271 # copied to $(tooldir)/sys-include.
272 if [ x"${with_headers}" != x ]; then
273 if [ x${is_cross_compiler} = xno ]; then
274 echo 1>&2 '***' --with-headers is only supported when cross compiling
275 exit 1
276 fi
277 case "${exec_prefixoption}" in
278 "") x=${prefix} ;;
279 *) x=${exec_prefix} ;;
280 esac
281 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
282 fi
283
284 # Handle --with-libs=XXX. Multiple directories are permitted. The
285 # contents are copied to $(tooldir)/lib.
286 if [ x"${with_libs}" != x ]; then
287 if [ x${is_cross_compiler} = xno ]; then
288 echo 1>&2 '***' --with-libs is only supported when cross compiling
289 exit 1
290 fi
291 # Copy the libraries in reverse order, so that files in the first named
292 # library override files in subsequent libraries.
293 case "${exec_prefixoption}" in
294 "") x=${prefix} ;;
295 *) x=${exec_prefix} ;;
296 esac
297 for l in ${with_libs}; do
298 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
299 done
300 fi
301
302 # If both --with-headers and --with-libs are specified, default to
303 # --without-newlib.
304 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
305 if [ x"${with_newlib}" = x ]; then
306 with_newlib=no
307 fi
308 fi
309
310 # Recognize --with-newlib/--without-newlib.
311 if [ x${with_newlib} = xno ]; then
312 skipdirs="${skipdirs} target-newlib"
313 elif [ x${with_newlib} = xyes ]; then
314 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
315 fi
316
317 # Default to using --with-stabs for certain targets.
318 if [ x${with_stabs} = x ]; then
319 case "${target}" in
320 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
321 with_stabs=yes;
322 withoptions="${withoptions} --with-stabs"
323 ;;
324 esac
325 fi
326
327 # Handle ${copy_dirs}
328 set fnord ${copy_dirs}
329 shift
330 while [ $# != 0 ]; do
331 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
332 :
333 else
334 echo Copying $1 to $2
335
336 # Use the install script to create the directory and all required
337 # parent directories.
338 if [ -d $2 ]; then
339 :
340 else
341 echo >config.temp
342 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
343 fi
344
345 # Copy the directory, assuming we have tar.
346 # FIXME: Should we use B in the second tar? Not all systems support it.
347 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
348
349 # It is the responsibility of the user to correctly adjust all
350 # symlinks. If somebody can figure out how to handle them correctly
351 # here, feel free to add the code.
352
353 echo $1 > $2/COPIED
354 fi
355 shift; shift
356 done
357
358 # Configure extra directories which are host specific
359
360 case "${host}" in
361 i[3456]86-*-go32*)
362 configdirs="$configdirs dosrel" ;;
363 *-cygwin32*)
364 configdirs="$configdirs dosrel" ;;
365 esac
366
367 # Remove more programs from consideration, based on the host or
368 # target this usually means that a port of the program doesn't
369 # exist yet.
370
371 noconfigdirs=""
372
373 case "${host}" in
374 i[3456]86-*-vsta)
375 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
376 ;;
377 i[3456]86-*-go32)
378 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
379 ;;
380 *-*-cygwin32 | *-*-windows*)
381 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
382 ;;
383 ppc*-*-pe)
384 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
385 ;;
386 esac
387
388
389 case "${target}" in
390 *-*-netware)
391 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
392 ;;
393 *-*-vxworks*)
394 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
395 ;;
396 alpha-dec-osf*)
397 # ld works, but does not support shared libraries. emacs doesn't
398 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
399 # gas doesn't generate exception information.
400 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
401 ;;
402 alpha*-*-*vms*)
403 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
404 ;;
405 alpha*-*-*)
406 # newlib is not 64 bit ready
407 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
408 ;;
409 # start-sanitize-arc
410 arc-*-*)
411 noconfigdirs="$noconfigdirs target-libgloss"
412 ;;
413 # end-sanitize-arc
414 arm-*-pe*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 arm-*-riscix*)
418 noconfigdirs="$noconfigdirs ld target-libgloss"
419 ;;
420 # start-sanitize-d10v
421 d10v-*-*)
422 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-libgloss"
423 ;;
424 # end-sanitize-d10v
425 h8300*-*-* | \
426 h8500-*-*)
427 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
428 ;;
429 hppa*-*-*elf* | \
430 hppa*-*-lites*)
431 # Do configure ld/binutils/gas for this case.
432 ;;
433 hppa*-*-*)
434 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
435 # cc is gcc, and on any system a user should be able to link cc to
436 # whatever they want. FIXME, emacs emacs19).
437 case "${CC}" in
438 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
439 *) ;;
440 esac
441 noconfigdirs="$noconfigdirs ld shellutils"
442 ;;
443 i[3456]86-*-go32)
444 # but don't build gdb
445 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
446 ;;
447 *-*-cygwin32)
448 target_configdirs="$target_configdirs target-winsup"
449 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
450 # always build newlib.
451 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
452
453 # Can't build gdb for cygwin32 if not native.
454 case "${host}" in
455 *-*-cygwin32) ;; # keep gdb
456 *) noconfigdirs="$noconfigdirs gdb"
457 esac
458 ;;
459 i[3456]86-*-pe)
460 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
461 ;;
462 i[3456]86-*-sco3.2v5*)
463 # The linker does not yet know about weak symbols in COFF,
464 # and is not configured to handle mixed ELF and COFF.
465 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
466 ;;
467 i[3456]86-*-sco*)
468 noconfigdirs="$noconfigdirs gprof target-libgloss"
469 ;;
470 i[3456]86-*-solaris2*)
471 # The linker does static linking correctly, but the Solaris C library
472 # has bugs such that some important functions won't work when statically
473 # linked. (See man pages for getpwuid, for example.)
474 noconfigdirs="$noconfigdirs ld target-libgloss"
475 ;;
476 i[3456]86-*-sysv4*)
477 # The SYSV4 C compiler doesn't handle Emacs correctly
478 case "${CC}" in
479 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
480 *) ;;
481 esac
482 # but that's okay since emacs doesn't work anyway
483 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
484 ;;
485 # start-sanitize-m32r
486 m32r-*-*)
487 noconfigdirs="$noconfigdirs target-libgloss libio libstdc++ libg++ gdb"
488 ;;
489 # end-sanitize-m32r
490 powerpc-*-aix*)
491 # copied from rs6000-*-* entry
492 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
493 # This is needed until gcc and ld are fixed to work together.
494 use_gnu_ld=no
495 ;;
496 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
497 target_configdirs="$target_configdirs target-winsup"
498 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
499 # always build newlib.
500 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
501 ;;
502 # This is temporary until we can link against shared libraries
503 powerpcle-*-solaris*)
504 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
505 ;;
506 rs6000-*-lynxos*)
507 # The CVS server code doesn't work on the RS/6000
508 # Newlib makes problems for libg++ in crosses.
509 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
510 ;;
511 rs6000-*-aix*)
512 noconfigdirs="$noconfigdirs gprof"
513 # This is needed until gcc and ld are fixed to work together.
514 use_gnu_ld=no
515 ;;
516 rs6000-*-*)
517 noconfigdirs="$noconfigdirs gprof"
518 ;;
519 m68k-apollo-*)
520 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
521 ;;
522 mips*-*-irix5*)
523 # The GNU linker does not support shared libraries.
524 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
525 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
526 ;;
527 mips*-*-irix6*)
528 # The GNU linker does not support shared libraries.
529 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
530 # BFD does not have Irix 6 support yet.
531 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
532 ;;
533 mips*-dec-bsd*)
534 noconfigdirs="$noconfigdirs gprof target-libgloss"
535 ;;
536 mips*-*-bsd*)
537 noconfigdirs="$noconfigdirs gprof target-libgloss"
538 ;;
539 mips*-*-*)
540 noconfigdirs="$noconfigdirs gprof"
541 ;;
542 romp-*-*)
543 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
544 ;;
545 sh-*-*)
546 case "${host}" in
547 i[3456]86-*-vsta) ;; # don't add gprof back in
548 i[3456]86-*-go32) ;; # don't add gprof back in
549 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
550 esac
551 noconfigdirs="$noconfigdirs target-libgloss"
552 ;;
553 sparc-*-sunos4*)
554 if [ x${is_cross_compiler} != xno ] ; then
555 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
556 else
557 use_gnu_ld=no
558 fi
559 ;;
560 v810-*-*)
561 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
562 ;;
563 # start-sanitize-v850
564 v850-*-*)
565 noconfigdirs="$noconfigdirs target-libgloss"
566 ;;
567 # end-sanitize-v850
568 vax-*-vms)
569 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
570 ;;
571 vax-*-*)
572 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
573 ;;
574 *-*-lynxos*)
575 # Newlib makes problems for libg++ in crosses.
576 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
577 ;;
578 *-*-macos* | \
579 *-*-mpw*)
580 # Macs want a resource compiler.
581 configdirs="$configdirs grez"
582 ;;
583 esac
584
585 # targets that need a second pass
586 case "${target}" in
587 *-gm-magic*)
588 noconfigdirs="$noconfigdirs target-libgloss"
589 ;;
590 esac
591
592 # If we aren't building newlib, then don't build libgloss, since libgloss
593 # depends upon some newlib header files.
594 case "${noconfigdirs}" in
595 *target-libgloss*) ;;
596 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
597 esac
598
599 # If we are building a Canadian Cross, discard tools that can not be built
600 # using a cross compiler. FIXME: These tools should be fixed.
601 if [ "${build}" != "${host}" ]; then
602 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
603 fi
604
605 # Make sure we don't let GNU ld be added if we didn't want it.
606 if [ x$with_gnu_ld = xno ]; then
607 use_gnu_ld=no
608 noconfigdirs="$noconfigdirs ld"
609 fi
610
611 # Make sure we don't let GNU as be added if we didn't want it.
612 if [ x$with_gnu_as = xno ]; then
613 use_gnu_as=no
614 noconfigdirs="$noconfigdirs gas"
615 fi
616
617 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
618 # $target_configdirs.
619 # If we have the source for $noconfigdirs entries, add them to $notsupp.
620
621 notsupp=""
622 for dir in . $skipdirs $noconfigdirs ; do
623 dirname=`echo $dir | sed -e s/target-//g`
624 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
625 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
626 if [ -r $srcdir/$dirname/configure ] \
627 || [ -r $srcdir/$dirname/configure.in ]; then
628 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
629 true
630 else
631 notsupp="$notsupp $dir"
632 fi
633 fi
634 fi
635 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
636 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
637 if [ -r $srcdir/$dirname/configure ] \
638 || [ -r $srcdir/$dirname/configure.in ]; then
639 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
640 true
641 else
642 notsupp="$notsupp $dir"
643 fi
644 fi
645 fi
646 done
647
648 # Sometimes the tools are distributed with libiberty but with no other
649 # libraries. In that case, we don't want to build target-libiberty.
650 if [ -n "${target_configdirs}" ]; then
651 others=
652 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
653 if [ "$i" != "libiberty" ]; then
654 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
655 others=yes;
656 break;
657 fi
658 fi
659 done
660 if [ -z "${others}" ]; then
661 target_configdirs=
662 fi
663 fi
664
665 # Deconfigure all subdirectories, in case we are changing the
666 # configuration from one where a subdirectory is supported to one where it
667 # is not.
668 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
669 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
670 rm -f $i/Makefile
671 done
672 fi
673 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
674 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
675 rm -f ${target_subdir}/$i/Makefile
676 done
677 fi
678
679 # Produce a warning message for the subdirs we can't configure.
680 # This isn't especially interesting in the Cygnus tree, but in the individual
681 # FSF releases, it's important to let people know when their machine isn't
682 # supported by the one or two programs in a package.
683
684 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
685 # If $appdirs is non-empty, at least one of those directories must still
686 # be configured, or we error out. (E.g., if the gas release supports a
687 # specified target in some subdirs but not the gas subdir, we shouldn't
688 # pretend that all is well.)
689 if [ -n "$appdirs" ]; then
690 for dir in $appdirs ; do
691 if [ -r $dir/Makefile.in ]; then
692 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
693 appdirs=""
694 break
695 fi
696 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
697 appdirs=""
698 break
699 fi
700 fi
701 done
702 if [ -n "$appdirs" ]; then
703 echo "*** This configuration is not supported by this package." 1>&2
704 exit 1
705 fi
706 fi
707 # Okay, some application will build, or we don't care to check. Still
708 # notify of subdirs not getting built.
709 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
710 echo " ${notsupp}" 1>&2
711 echo " (Any other directories should still work fine.)" 1>&2
712 fi
713
714 # Set with_gnu_as and with_gnu_ld as appropriate.
715 #
716 # This is done by determining whether or not the appropriate directory
717 # is available, and by checking whether or not specific configurations
718 # have requested that this magic not happen.
719 #
720 # The command line options always override the explicit settings in
721 # configure.in, and the settings in configure.in override this magic.
722 #
723 # If the default for a toolchain is to use GNU as and ld, and you don't
724 # want to do that, then you should use the --without-gnu-as and
725 # --without-gnu-ld options for the configure script.
726
727 if [ x${use_gnu_as} = x ] ; then
728 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
729 with_gnu_as=yes
730 withoptions="$withoptions --with-gnu-as"
731 fi
732 fi
733
734 if [ x${use_gnu_ld} = x ] ; then
735 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
736 with_gnu_ld=yes
737 withoptions="$withoptions --with-gnu-ld"
738 fi
739 fi
740
741 if [ x${shared} = xyes ]; then
742 case "${target}" in
743 hppa*) target_makefile_frag=config/mt-papic ;;
744 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
745 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
746 esac
747 fi
748
749 # post-target:
750
751 # Make sure that the compiler is able to generate an executable. If it
752 # can't, we are probably in trouble. We don't care whether we can run the
753 # executable--we might be using a cross compiler--we only care whether it
754 # can be created. At this point the main configure script has set CC.
755 echo "int main () { return 0; }" > conftest.c
756 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
757 if [ $? = 0 ] && [ -s conftest ]; then
758 :
759 else
760 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
761 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
762 rm -f conftest*
763 exit 1
764 fi
765 rm -f conftest*
766
767 # The Solaris /usr/ucb/cc compiler does not appear to work.
768 case "${host}" in
769 sparc-sun-solaris2*)
770 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
771 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
772 could_use=
773 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
774 if [ -d /opt/cygnus/bin ] ; then
775 if [ "$could_use" = "" ] ; then
776 could_use="/opt/cygnus/bin"
777 else
778 could_use="$could_use or /opt/cygnus/bin"
779 fi
780 fi
781 if [ "$could_use" = "" ] ; then
782 echo "Warning: compilation may fail because you're using"
783 echo "/usr/ucb/cc. You should change your PATH or CC "
784 echo "variable and rerun configure."
785 else
786 echo "Warning: compilation may fail because you're using"
787 echo "/usr/ucb/cc, when you should use the C compiler from"
788 echo "$could_use. You should change your"
789 echo "PATH or CC variable and rerun configure."
790 fi
791 fi
792 ;;
793 esac
794
795 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
796 # binutils tools will find libbfd.so.
797 if [ "${shared}" = "yes" ]; then
798 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
799 Makefile > Makefile.tem
800 rm -f Makefile
801 mv -f Makefile.tem Makefile
802
803 case "${host}" in
804 *-*-hpux*)
805 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
806 Makefile > Makefile.tem
807 rm -f Makefile
808 mv -f Makefile.tem Makefile
809 ;;
810 esac
811 fi
812
813 # Record target_configdirs and the configure arguments in Makefile.
814 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
815 targargs=`echo "${arguments}" | \
816 sed -e 's/--norecursion//' \
817 -e 's/--cache[a-z-]*=[^ ]*//' \
818 -e 's/--ho[a-z-]*=[^ ]*//' \
819 -e 's/--ta[a-z-]*=[^ ]*//'`
820
821 # Passing a --with-cross-host argument lets the target libraries know
822 # whether they are being built with a cross-compiler or being built
823 # native. However, it would be better to use other mechanisms to make the
824 # sorts of decisions they want to make on this basis. Please consider
825 # this option to be deprecated. FIXME.
826 if [ x${is_cross_compiler} = xyes ]; then
827 targargs="--with-cross-host=${host_alias} ${targargs}"
828 fi
829
830 targargs="--host=${target_alias} ${targargs}"
831 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
832 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
833 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
834 Makefile > Makefile.tem
835 rm -f Makefile
836 mv -f Makefile.tem Makefile
837
838 #
839 # Local Variables:
840 # fill-column: 131
841 # End:
842 #
This page took 0.061773 seconds and 4 git commands to generate.